(function ($) {
$.widget('ui.apex_modal_page', {
   options: {
      transition: null,
      loadingImageSrc: null,
      initialHeight: null,
      initialWidth: null,
      overlayOpacity: null,
      scrolling: null,
      draggable: null
   },
   _createPrivateStorage: function() {
      var uiw = this;
      
      if ($('#pdebug').length){
         apex.debug('Modal Page - Start "_createPrivateStorage"');
      }
      
      uiw._values = {
         url: null, 
         dialogTitle: null, 
         closeSelector: null, 
         preventDefault: null, 
         heightWidthMode: null,
         height: null,
         width: null,
         closeElementSelector: null,
         modalPageId: null,
         modalPageCloseValue: null,
         dialogTop: 0,
         dialogLeft: 0,
         iframeHeight: 0,
         iframeWidth: 0,
         hasVScroll: false,
         hasHScroll: false,
         autoClosed: false,
         debug: $('#pdebug').length !== 0
      };
      
      uiw._elements = {
         $window: {},
         $dialog: {},
         $wrapper: {},
         $iframe: {}
      };
      
      if (uiw._values.debug){
         apex.debug('Modal Page - End "_createPrivateStorage"');
      }
   },
   _create: function() {
      var uiw = this;
      var loadImg = new Image();
      loadImg.src = uiw.options.loadingImageSrc;
      
      if ($('#pdebug').length){
         apex.debug('Modal Page - Start "_create"');
         apex.debug('...Options');
         
         for (name in uiw.options) {
            apex.debug('......' + name + ': "' + uiw.options[name] + '"');
         }
      }

      uiw._createPrivateStorage();
      uiw._elements.$window = $(window);
      
      if (uiw._values.debug){
         apex.debug('Modal Page - End "_create"');
      }
   },
   openPage: function(dialogTitle, closeSelector, modalPageId, heightWidthMode, height, width) {
      var uiw = this;
      var defaults = {
         'title': undefined,
         'closeSelector': undefined,
         'modalPageId': undefined,
         'height': undefined
      }
      
      if (uiw._values.debug){
         apex.debug('Modal Page - Start "openPage"');
      }
      
      uiw._values.autoClosed = false;
      uiw._values.dialogTitle = dialogTitle; 
      uiw._values.closeElementSelector = closeSelector;
      uiw._values.modalPageId = modalPageId;
      uiw._values.heightWidthMode = heightWidthMode;      
      uiw._values.height = height;
      uiw._values.width = width;
      
      $.colorbox({
         transition: uiw.options.transition,
         title: uiw._values.dialogTitle,
         height: uiw.options.initialHeight + 'px',//uiw._values.height,
         //initialHeight: uiw.options.initialHeight + 'px',
         width: uiw.options.initialWidth + 'px',//uiw._values.width,
         //initialWidth: uiw.options.initialWidth + 'px',
         iframe: true,
         scrolling: uiw.options.scrolling,
         fastIframe: false,
         overlayClose: false,
         opacity: uiw.options.overlayOpacity,
         href: uiw._values.url,
         onOpen: function() {
            if (uiw.options.draggable) {
               $('#colorbox')
                  .draggable()
                  .css('cursor','move');
            }
            
            $(document).trigger('apexmodalpageopen');
         },
         onComplete: function() {
            uiw._handleIframeLoad();
            
            $(document).trigger('apexmodalpagecomplete');
         },
         onCleanup: function() { 
            uiw._elements.$window.unbind('resize', uiw._checkResizeTimer);
            
            if (!uiw._values.autoClosed) {
               $(document).trigger('modalpagemanualclose', {
                  "modalPageId": uiw._values.modalPageId,
                  "modalPageCloseValue": ((uiw._values.modalPageCloseValue) ? uiw._values.modalPageCloseValue : "")
               });
            }
            
            uiw._values.modalPageCloseValue = null;
         },
         onClosed: function() {
            $(document).trigger('apexmodalpageclosed');
         }
      });

      uiw._elements.$window.bind('resize', {uiw: uiw}, uiw._checkResizeTimer);
      
      if (uiw._values.debug){
         apex.debug('Modal Page - End "openPage"');
      }
   },
   openPageFromApexThis: function(apexThis) {
      var uiw = this;
      var urlLocation = apexThis.action.attribute02;
      var staticUrl = apexThis.action.attribute03;
      var attrName = apexThis.action.attribute05; 
      var hwMode = apexThis.action.attribute07;
      var height;
      var width;
      
      if (uiw._values.debug){
         apex.debug('Modal Page - Start "openPageFromApexThis"');
      }
      
      if (urlLocation === 'STATIC') {
         uiw._values.url = staticUrl;
      } else if (urlLocation === 'TRIG_ELEMENT_ATTR') {
         uiw._values.url = $(apexThis.triggeringElement).attr(attrName);
      }
      
      if (hwMode === 'AUTO') {
         height = false;
         width = false;
      } else if (hwMode === 'STATIC_PX') {
         height = apexThis.action.attribute08 + 'px';
         width = apexThis.action.attribute09 + 'px';
      } else if (hwMode === 'STATIC_%') {
         height = apexThis.action.attribute08 + '%';
         width = apexThis.action.attribute09 + '%';
      }
      
      uiw.openPage(
         apexThis.action.attribute01,
         apexThis.action.attribute06,
         apexThis.action.attribute10,
         hwMode,
         height,
         width
      );  
      
      if (uiw._values.debug){
         apex.debug('Modal Page - End "openPageFromApexThis"');
      }
   },
   _handleIframeLoad: function() {
      var uiw = this;
      uiw._elements.$iframe = $('#colorbox iframe');
      var $closeElementSelector = uiw._elements.$iframe.contents().find(uiw._values.closeElementSelector);
      var childWindow = uiw._elements.$iframe.get(0).contentWindow;
      var jQIframe = childWindow.apex.jQuery;
      
      if (uiw._values.debug){
         apex.debug('Modal Page - Start "_handleIframeLoad"');
      }
      
      jQIframe(uiw._elements.$iframe.contents().get(0)).bind('apexbeforepagesubmit', function() {
         $('#cboxLoadedContent').hide();
         $('#cboxLoadingOverlay').show();
         $('#cboxLoadingGraphic').show();
      });
      
      uiw._elements.$iframe.contents().find('#apex-dev-toolbar,#htmldbDevToolbar').remove();
      
      if ($closeElementSelector.length) {
         uiw._values.autoClosed = true;
      
         jQuery.colorbox.close();
         
         $(document).trigger('modalpageautoclose', {
            "modalPageId": uiw._values.modalPageId,
            "$modalPageCloseObject": $closeElementSelector.clone(true)
         });
      } else {
         uiw._elements.$iframe.contents().find('body').css('margin', '0px');
         
         $('#cboxLoadingOverlay').hide();
         $('#cboxLoadingGraphic').hide();
         $('#cboxLoadedContent').show();

         uiw._resizeModal();
         
         uiw._elements.$iframe.removeClass('ui-helper-hidden-accessible');
      
         uiw._elements.$iframe.one('load', function() {
            uiw._handleIframeLoad();
         });
      }
      
      if (uiw._values.debug){
         apex.debug('Modal Page - End "_handleIframeLoad"');
      }
   },
   _resizeModal: function(opts) {
      var uiw = this;
      
      if (uiw._values.debug){
         apex.debug('Modal Page - Start "_resizeModal"');
      }
      
      uiw._elements.$window.unbind('resize', uiw._checkResizeTimer);
      
      if (opts) {
         jQuery.colorbox.resize({
            'width': opts.width,
            'height': opts.height,
            'innerHeight': opts.innerHeight,
            'innerWidth': opts.innerWidth
         });
      } else if (uiw._values.heightWidthMode === 'AUTO') {
         jQuery.colorbox.resize({
            'innerHeight': uiw._elements.$iframe.contents().height(),
            'innerWidth': uiw._elements.$iframe.contents().width()
         });  
      } else {
         jQuery.colorbox.resize({
            'innerHeight': uiw._values.height,
            'innerWidth': uiw._values.width
         });
      }
      
      uiw._elements.$window.bind('resize', {uiw: uiw}, uiw._checkResizeTimer);
      
      if (uiw._values.debug){
         apex.debug('Modal Page - End "_resizeModal"');
      }
   },
   _checkResizeTimer: function(eventObj) {
      var uiw = eventObj.data.uiw;
      
      if (uiw._values.debug){
         apex.debug('Modal Page - Start "_checkResizeTimer"');
      }
      
      if (uiw._values.timer) {
         clearTimeout(uiw._values.timer);
      }

      uiw._values.timer = setTimeout(function() {uiw._handleWindowResize();}, 50);
      
      if (uiw._values.debug){
         apex.debug('Modal Page - End "_checkResizeTimer"');
      }
   },
   _handleWindowResize: function() {
      var uiw = this;
      
      if (uiw._values.debug){
         apex.debug('Modal Page - Start "_handleWindowResize"');
      }
      
      if (uiw._values.heightWidthMode !== 'AUTO') {
         uiw._resizeModal();    
      }
      
      if (uiw._values.debug){
         apex.debug('Modal Page - End "_handleWindowResize"');
      }
   },
   close: function(modalPageCloseValue) { 
      var uiw = this;
      
      if (uiw._values.debug){
         apex.debug('Modal Page - Start "close"');
      }
      
      uiw._values.modalPageCloseValue = modalPageCloseValue;   
      jQuery.colorbox.close();
      
      if (uiw._values.debug){
         apex.debug('Modal Page - End "close"');
      }
   },
   resize: function(opts){
      uiw = this;
      
      if (uiw._values.debug){
         apex.debug('Modal Page - Start "resize"');
      }
      
      uiw._resizeModal(opts);
      
      if (uiw._values.debug){
         apex.debug('Modal Page - End "resize"');
      }
   }
});
})(apex.jQuery);